{
       API  

    15.12.2006

     :        (rpy3uH)
    E-mail:     ahilles1806@rambler.ru

}

unit ApiHookTools;

interface

uses Windows,TlHelp32;

const
  THREAD_ALL_ACCESS      = $001F03FF;
  THREAD_SUSPEND_RESUME  = $00000002;

type
  PFunctionRestoreData = ^ TFunctionRestoreData;
  TFunctionRestoreData = packed record
    Address:Pointer;
    val1:Byte;
    val2:DWORD;
   end;

function EnableDebugPrivilege:Boolean;

Function GetProcessName(ProcessID:DWORD):string;
function GetProcessID(ProcessName:string):DWORD;
Function StopProcess(ProcessID: DWORD): boolean;
Function ResumeProcess(ProcessID: DWORD): Boolean;

function LoadLibrary_Ex(ProcessID:DWORD;LibName:PChar):boolean;

function SetCodeHook(ProcAddress,NewProcAddress:pointer;RestoreDATA:PFunctionRestoreData):boolean;
function UnHookCodeHook(RestoreDATA:PFunctionRestoreData):Boolean;
function SetProcedureHook(ModuleHandle:HMODULE;ProcedureName:PChar;NewProcedureAddress:Pointer;
   RestoreDATA:PFunctionRestoreData):Boolean;


Function OpenThread(dwDesiredAccess: DWORD;bInheritHandle: BOOL;
      dwThreadID: DWORD): THandle; stdcall; external 'kernel32.dll'; 

implementation

{-----------------------------------------------------------------------------
        

  Procedure: SetProcedureHook

  ModuleHandle:HMODULE;                    
  ProcedureName:PChar;               
  NewProcedureAddress:Pointer;         
  RestoreDATA:PFunctionRestoreData       

  Result:    Boolean                  
-----------------------------------------------------------------------------}

function SetProcedureHook(ModuleHandle:HMODULE;ProcedureName:PChar;NewProcedureAddress:Pointer;
   RestoreDATA:PFunctionRestoreData):Boolean;
var
  ProcAddress:Pointer;
begin
  ProcAddress:=GetProcAddress(ModuleHandle,ProcedureName);
  Result:=SetCodeHook(ProcAddress,NewProcedureAddress,RestoreDATA);
end;

{-----------------------------------------------------------------------------
    

  Procedure: UnHookCodeHook

  RestoreDATA:PFunctionRestoreData      

  Result:    Boolean
-----------------------------------------------------------------------------}


function UnHookCodeHook(RestoreDATA:PFunctionRestoreData):Boolean;
var
  ProcAddress:Pointer;
  OldProtect,JMPValue:DWORD;
begin
  Result:=False;
  ProcAddress:=RestoreDATA^.Address;
  if not VirtualProtect(ProcAddress,5,PAGE_EXECUTE_READWRITE,OldProtect) then exit;
  Byte(ProcAddress^):=RestoreDATA^.val1;
  DWORD(Pointer(DWORD(ProcAddress)+1)^):=RestoreDATA^.val2;
  Result:=VirtualProtect(ProcAddress,5,OldProtect,OldProtect);
end;
{-----------------------------------------------------------------------------
       

  Procedure: SetCodeHook

  ProcAddress,                          
  NewProcAddress:pointer;              
  RestoreDATA:PFunctionRestoreData       


  Result:    boolean                
-----------------------------------------------------------------------------}


function SetCodeHook(ProcAddress, NewProcAddress: pointer; RestoreDATA:PFunctionRestoreData):boolean;
var
  OldProtect, JMPValue:DWORD;
begin
  Result:=False;
  if not VirtualProtect(ProcAddress,5,PAGE_EXECUTE_READWRITE,OldProtect) then exit;
  JMPValue := DWORD(NewProcAddress) - DWORD(ProcAddress) - 5;
  RestoreDATA^.val1:= Byte(ProcAddress^);
  RestoreDATA^.val2:= DWORD(Pointer(DWORD(ProcAddress)+1)^);
  RestoreDATA^.Address:=ProcAddress;
  byte(ProcAddress^):=$E9;
  DWORD(Pointer(DWORD(ProcAddress)+1)^):=JMPValue;
  Result:=VirtualProtect(ProcAddress,5,OldProtect,OldProtect);
end;


{-----------------------------------------------------------------------------
   DLL   
  Procedure: LoadLibrary_Ex

  ProcessID:DWORD;
  LibName:PChar
  
  Result:    boolean
-----------------------------------------------------------------------------}
function LoadLibrary_Ex(ProcessID:DWORD;LibName:PChar):boolean;
var
  pLL,pDLLPath:Pointer;
  hProcess,hThr:THandle;
  LibPathLen,_WR,ThrID:DWORD;
begin
  Result:=False;
  LibPathLen:=Length(string(LibName));
  hProcess:=OpenProcess(PROCESS_ALL_ACCESS,false,ProcessID);
  if hProcess=0 then exit;
  pDLLPath:=VirtualAllocEx(hProcess,0,LibPathLen+1,MEM_COMMIT,PAGE_READWRITE);
  if DWORD(pDLLPath)=0 then exit;
  pLL:=GetProcAddress(GetModuleHandle(kernel32),'LoadLibraryA');
  WriteProcessMemory(hProcess,pDLLPath,LibName,LibPathLen+1,_WR);
  hThr:=CreateRemoteThread(hProcess,0,0,pLL,pDLLPath,0,ThrID);
  if hThr=0 then exit;
  Result:=CloseHandle(hProcess);
end;

function GetProcessID;
var
  Snap: dword;
  Process: TPROCESSENTRY32;
begin
  Result := 0;
  Snap := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if Snap <> INVALID_HANDLE_VALUE then
     begin
      Process.dwSize := SizeOf(TPROCESSENTRY32);
      if Process32First(Snap, Process) then
         repeat
          if lstrcmpi(Process.szExeFile, pchar(ProcessName)) = 0 then
             begin
              Result := Process.th32ProcessID;
              CloseHandle(Snap);
              Exit;
             end;
         until not Process32Next(Snap, Process);
      Result := 0;
      CloseHandle(Snap);
     end;
end;

Function GetProcessName;
var Snapshot:THandle;
    Process: TPROCESSENTRY32;
begin
  Result:='';
  Snapshot := CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);
  if Snapshot = INVALID_HANDLE_VALUE then exit;
  Process.dwSize := SizeOf(TPROCESSENTRY32);
  if Process32First(SnapShot, Process) then
   repeat
    if ProcessID=Process.th32ProcessID then
     begin
      Result := Process.szExeFile;
      CloseHandle(Snapshot);
      Exit;
     end;
   until not Process32Next(Snapshot, Process);
   CloseHandle(Snapshot);
end;

function EnableDebugPrivilege:Boolean;
var
  hToken: dword;
  SeDebugNameValue: Int64;
  tkp: TOKEN_PRIVILEGES;
  ReturnLength: dword;
begin
  Result:=false;
  //   
  OpenProcessToken(INVALID_HANDLE_VALUE, TOKEN_ADJUST_PRIVILEGES
                  or TOKEN_QUERY, hToken);
  // LUID 
  if not LookupPrivilegeValue(nil, 'SeDebugPrivilege', SeDebugNameValue) then
   begin
    CloseHandle(hToken);
    exit;
   end;
  tkp.PrivilegeCount := 1;
  tkp.Privileges[0].Luid := SeDebugNameValue;
  tkp.Privileges[0].Attributes := SE_PRIVILEGE_ENABLED;
  //   
  AdjustTokenPrivileges(hToken, false, tkp, SizeOf(TOKEN_PRIVILEGES),
                        tkp, ReturnLength);
  Result:= GetLastError = ERROR_SUCCESS;
end;

Function StopProcess(ProcessID: DWORD): boolean;
var
  Snapshot,cThr: dword;
  ThrHandle: THandle;
  Thread:TThreadEntry32;
begin
  Result := False;
  cThr := GetCurrentThreadId;
  Snapshot := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
  if Snapshot <> INVALID_HANDLE_VALUE then
   begin
    Thread.dwSize := SizeOf(TThreadEntry32);
    if Thread32First(Snapshot, Thread) then
     repeat
      if (Thread.th32ThreadID <> cThr) and (Thread.th32OwnerProcessID = ProcessID) then
       begin
        ThrHandle := OpenThread(THREAD_ALL_ACCESS, false, Thread.th32ThreadID);
        if ThrHandle = 0 then Exit;
        SuspendThread(ThrHandle);
        CloseHandle(ThrHandle);
       end;
     until not Thread32Next(Snapshot, Thread);
     Result:=CloseHandle(Snapshot);
   end;
end;

Function ResumeProcess(ProcessID: DWORD): Boolean;
var
  Snapshot,cThr: DWORD;
  ThrHandle: THandle;
  Thread:TThreadEntry32;
begin
  Result := False;
  cThr := GetCurrentThreadId;
  Snapshot := CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0);
  if Snapshot <> INVALID_HANDLE_VALUE then
   begin
    Thread.dwSize := SizeOf(TThreadEntry32);
    if Thread32First(Snapshot, Thread) then
     repeat
      if (Thread.th32ThreadID <> cThr) and (Thread.th32OwnerProcessID = ProcessID) then
       begin
        ThrHandle := OpenThread(THREAD_ALL_ACCESS, false, Thread.th32ThreadID);
        if ThrHandle = 0 then Exit;
        ResumeThread(ThrHandle);
        CloseHandle(ThrHandle);
       end;
     until not Thread32Next(Snapshot, Thread);
     Result := CloseHandle(Snapshot);
    end;
end;

end.
